%define name popa3d
%define version 0.4
%define release 3+pam+whoson

Summary: Popa3d is a tiny POP3 daemon, designed with security as the primary goal.
Name: %{name}
Version: %{version}
Release: %{release}
Copyright: GPL
Group: Networking/Daemons
URL: http://www.openwall.com/popa3d
Source0: popa3d-0.4.tar.gz
Source1: popa3d.pam
Source2: popa3d.init
Patch0: popa3d-whoson-0.2.patch
Patch1: popa3d-0.4.glibc-pam.patch
Distribution: None
Packager: Tomasz Rzad <tomasz@rzad.com>
BuildRoot: /var/tmp/%{name}-%{version}
Conflicts: imap
BuildRequires: dialog

%description
Popa3d is a pop3 daemon which attempts to be extremely secure, reliable, RFC compliant and fast.
This version supports PAM and whoson (WHO iS ONline) protocol.

%prep
%setup -q
%patch0 -p1
%patch1 -p1

%build
dialog --nocancel --inputbox "Give the address to listen at (for instance: 127.0.0.1) - 0.0.0.0 for listeing on all interfaces" 10 76 "0.0.0.0" 2> %{DAEMON_ADDR}
dialog --nocancel --inputbox "Give port number to listen at (default 110)" 10 76 "110" 2> %{DAEMON_PORT}
dialog --nocancel --inputbox "Give maximum of mailbox messages" 10 76 "100000" 2> %{MAX_MAILBOX_MESSAGE}
dialog --nocancel --inputbox "Give maximum bytes of mailbox" 10 76 "100000000" 2> %{MAX_MAILBOX_BYTES}

DAEMON_ADDR=`cat %{DAEMON_ADDR}`
DAEMON_PORT=`cat %{DAEMON_PORT}`
MAX_MAILBOX_MESSAGE=`cat %{MAX_MAILBOX_MESSAGE}`
MAX_MAILBOX_BYTES=`cat %{MAX_MAILBOX_BYTES}`

cat params.h | sed -e "18,24s/0.0.0.0/${DAEMON_ADDR}/" -e "19,23s/110/${DAEMON_PORT}/" -e "58,13s/100000/${MAX_MAILBOX_MESSAGE}/" -e "59,28s/100000000/${MAX_MAILBOX_BYTES}/" > params_new.h
mv params_new.h params.h

CFLAGS=$RPM_OPT_FLAGS \
make clean
make CC=gcc

%install
if [ -d $RPM_BUILD_ROOT ]; then rm -r $RPM_BUILD_ROOT ; fi
mkdir -p $RPM_BUILD_ROOT/usr/sbin
mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
mkdir -p $RPM_BUILD_ROOT/etc/pam.d

cp popa3d $RPM_BUILD_ROOT/usr/sbin/popa3d
chmod 755 $RPM_BUILD_ROOT/usr/sbin/popa3d
cp $RPM_SOURCE_DIR/popa3d.init $RPM_BUILD_ROOT/etc/rc.d/init.d/popa3d
chmod 700 $RPM_SOURCE_DIR/popa3d.init $RPM_BUILD_ROOT/etc/rc.d/init.d/popa3d
cp $RPM_SOURCE_DIR/popa3d.pam $RPM_BUILD_ROOT/etc/pam.d/popa3d
chmod 600 $RPM_SOURCE_DIR/popa3d.pam $RPM_BUILD_ROOT/etc/pam.d/popa3d

%clean
rm -rf $RPM_BUILD_ROOT

%post

if [ "$1" = 1 ]
then
        # check that user 'popa3d' exists
        #
        if grep "^popa3d:" /etc/passwd > /dev/null
        then
                true
        else
                useradd -d /dev/null -s /dev/null popa3d
        fi
fi
/sbin/chkconfig --add popa3d

%preun
/sbin/chkconfig --del popa3d

%postun
if [ "$1" = 0 ]
then
        echo "Consider deleting user 'popa3d' too." 1>&2
fi


%files
%defattr(-,root,root)
/usr/sbin/popa3d
/etc/rc.d/init.d/popa3d
/etc/pam.d/popa3d
%doc DESIGN INSTALL
